/*
 * The Cryptonit security software suite is developped by IDEALX
 * Cryptonit Team (http://IDEALX.org/ and http://cryptonit.org).
 *
 * Copyright 2003-2006 IDEALX
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301, USA. 
 *
 * In addition, as two special exceptions:
 *
 * 1) IDEALX S.A.S gives permission to:
 *  * link the code of portions of his program with the OpenSSL library under
 *    certain conditions described in each source file
 *  * distribute linked combinations including the two, with respect to the
 *    OpenSSL license and with the GPL
 *
 * You must obey the GNU General Public License in all respects for all of the
 * code used other than OpenSSL. If you modify file(s) with this exception,
 * you may extend this exception to your version of the file(s), but you are
 * not obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version, in all files (this very one along with all
 * source files).

 * 2) IDEALX S.A.S acknowledges that portions of his sourcecode uses (by the
 * way of headers inclusion) some work published by 'RSA Security Inc.'. Those
 * portions are "derived from the RSA Security Inc. PKCS #11Cryptographic
 * Token Interface (Cryptoki)" as described in each individual source file.
 */

#ifndef _AddressBookFrame_hh_
#define _AddressBookFrame_hh_

#include <wx/wx.h>
#include <wx/toolbar.h>
#include <wx/bmpbuttn.h>
#include <wx/listctrl.h>

#include <wx/statusbr.h>

#include "MainWindow.hh"
#include "../AddressBook.hh"
#include "../User.hh"
#include "../SoftKeyStore.hh"

using namespace Cryptonit;

class AddressBookFrame: public wxFrame
{

private:
    
    wxToolBar *addressBookToolBar;
    wxStatusBar *addressBookStatusBar;
    
    wxListCtrl *contactList;

    User *user;
    std::vector<KeyStore *> *keyStore;
    
    
    /* Array containing field to be displayed in the contactList */
    wxArrayString contactFieldList[2];
    bool *contactFieldListAscending;

    void createLocalAddressBookPage( wxPanel* panel );

    
    void createToolBar();
    void createStatusBar();
    void exit(wxCommandEvent& WXUNUSED(event));
    void exit2(wxCloseEvent& WXUNUSED(event));
    void addContact(wxCommandEvent& WXUNUSED(event));
    void editContact(wxListEvent& event);
    void removeContact(wxCommandEvent& event);
    void onColumnClick(wxListEvent& event);
    void configFields(wxCommandEvent& WXUNUSED(event));
    void initFieldList();
    void refreshLocalAddressBookPage();

    DECLARE_EVENT_TABLE();

	
public:
    MainWindow *p;
    
    
    AddressBookFrame( wxWindow* parent, 
		      wxWindowID id, 
		      const wxString& title, 
		      User* u,
		      std::vector<KeyStore *> *keySt,
		      const wxPoint& pos = wxDefaultPosition, 
		      const wxSize& size = wxDefaultSize, 
		      long style =  wxDEFAULT_FRAME_STYLE, 
		      const wxString& name = _("Address Book"));
    
    
    ~AddressBookFrame();
    
    void refreshContactList();

};

enum {
    AB_TOOLBAR_ID = 2000,
    AB_ADD_CONTACT_BTN_ID,
    AB_REMOVE_CONTACT_BTN_ID,
    AB_SEARCH_CONTACT_BTN_ID,
    AB_IMPORT_CONTACT_BTN_ID,
    AB_CLOSE_BTN_ID,
    AB_SELECT_CONTACT_ID,
    AB_SETTINGS_BTN_ID
};

#endif
