#ifndef PKCS11_PKEY_H
#define PKCS11_PKEY_H

/*
 * Copyright (C) 2003 Mathias Brossard <mathias.brossard@idealx.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *  
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02111-1301,
 * USA.
 *
 * In addition, as two special exceptions:
 *
 * 1) IDEALX S.A.S gives permission to:
 *  * link the code of portions of his program with the OpenSSL library under
 *    certain conditions described in each source file
 *  * distribute linked combinations including the two, with respect to the
 *    OpenSSL license and with the GPL
 *
 * You must obey the GNU General Public License in all respects for all of the
 * code used other than OpenSSL. If you modify file(s) with this exception,
 * you may extend this exception to your version of the file(s), but you are
 * not obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version, in all files (this very one along with all
 * source files).

 * 2) IDEALX S.A.S acknowledges that portions of his sourcecode uses (by the
 * way of headers inclusion) some work published by 'RSA Security Inc.'. Those
 * portions are "derived from the RSA Security Inc. PKCS #11Cryptographic
 * Token Interface (Cryptoki)" as described in each individual source file.
 */

#include <openssl/evp.h>
#include <openssl/rsa.h>
#include <openssl/x509.h>

#include "pkcs11_util.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  CK_FUNCTION_LIST_PTR funcs;
  CK_SESSION_HANDLE    h_session;
  CK_OBJECT_HANDLE     h_key;
  X509                 *x509;
} pkcs11_key_data;

EVP_PKEY *pkcs11_get_pkey(CK_FUNCTION_LIST_PTR funcs,
			  CK_SESSION_HANDLE    h_session,
			  CK_OBJECT_HANDLE     h_key,
			  X509                 *x509);

#ifdef __cplusplus
};
#endif

#endif
